/*
PAYMENTS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package paymentsapi

import (
	"encoding/json"
	"time"
)

// checks if the UnzerConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UnzerConfiguration{}

// UnzerConfiguration struct for UnzerConfiguration
type UnzerConfiguration struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	PublicKey string `json:"public_key"`
	ApiUrl string `json:"api_url"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewUnzerConfiguration instantiates a new UnzerConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUnzerConfiguration(id string, organizationId string, publicKey string, apiUrl string, createdAt time.Time, updatedAt time.Time) *UnzerConfiguration {
	this := UnzerConfiguration{}
	this.Id = id
	this.OrganizationId = organizationId
	this.PublicKey = publicKey
	this.ApiUrl = apiUrl
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewUnzerConfigurationWithDefaults instantiates a new UnzerConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUnzerConfigurationWithDefaults() *UnzerConfiguration {
	this := UnzerConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *UnzerConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *UnzerConfiguration) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *UnzerConfiguration) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *UnzerConfiguration) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetPublicKey returns the PublicKey field value
func (o *UnzerConfiguration) GetPublicKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetPublicKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PublicKey, true
}

// SetPublicKey sets field value
func (o *UnzerConfiguration) SetPublicKey(v string) {
	o.PublicKey = v
}

// GetApiUrl returns the ApiUrl field value
func (o *UnzerConfiguration) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *UnzerConfiguration) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *UnzerConfiguration) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *UnzerConfiguration) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *UnzerConfiguration) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *UnzerConfiguration) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *UnzerConfiguration) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o UnzerConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UnzerConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["public_key"] = o.PublicKey
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableUnzerConfiguration struct {
	value *UnzerConfiguration
	isSet bool
}

func (v NullableUnzerConfiguration) Get() *UnzerConfiguration {
	return v.value
}

func (v *NullableUnzerConfiguration) Set(val *UnzerConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullableUnzerConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullableUnzerConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUnzerConfiguration(val *UnzerConfiguration) *NullableUnzerConfiguration {
	return &NullableUnzerConfiguration{value: val, isSet: true}
}

func (v NullableUnzerConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUnzerConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


